︠e26b63b0-9ed5-46c2-8150-b805c258deb6i︠
%md
# SymPy `solveset` and unevaluated expressions

This is running in Anaconda Python, in Sympy 1.0
︡bfc856fb-caa5-4070-8aa8-527b458dfefa︡{"done":true,"md":"# SymPy `solveset` and unevaluated expressions\n\nThis is running in Anaconda Python, in Sympy 1.0"}
︠799a9497-9797-441a-acd7-1317c701079ds︠
%auto
%default_mode python3
︡48dfa85d-f65e-452f-a538-ed7ae4310699︡{"done":true}︡
︠7756894d-10f9-429f-b10f-c9f94b1139bbs︠
%auto
%python3
from sympy import *
x = Symbol('x')
init_printing()
︡3dbf6da4-d0b7-4696-aa19-c2a339eaec5b︡{"done":true}︡
︠15ce791d-aa37-40c4-9d63-aaa86bf51e59s︠
with evaluate(False):
    y = x/x
y
︡408d662d-5fcb-4976-8a22-bf5140f8397d︡{"file":{"filename":"/tmp/tmpmzcYdP.png","show":true,"text":null,"uuid":"27521712-2cc2-4306-82ff-dbe10444644a"},"once":false}︡{"done":true}︡
︠2e026893-6fa9-4865-b029-6ec18ba3ced7i︠
%md
Note, `**` for power in pure Python
︡1cf50cef-b221-4dc0-88ff-3c5480da04a5︡{"done":true,"md":"Note, `**` for power in pure Python"}
︠ecafa924-a052-4deb-bb8d-e80d6aaa4dc6︠
x**2/x
︡dc747d36-8d04-4bfc-b458-4be634e239e0︡{"file":{"filename":"/tmp/tmp5MB63d.png","show":true,"text":null,"uuid":"e0fe38cb-2242-401c-9960-4b01271e74af"},"once":false}︡{"done":true}︡
︠e6e4c670-9900-49fa-b686-91d91b589ccai︠
%md
`sympify` converts a string to an expression and `evaluate=False` suppresses simplification
︡96a6e7bc-dc8c-4f9a-9770-584f46ac3175︡{"done":true,"md":"`sympify` converts a string to an expression and `evaluate=False` suppresses simplification"}
︠9876a430-d04b-4eb6-b1f4-36499b7f7637︠
sympify('x^2 / x', evaluate=False)
︡0befd4be-a1cb-42ed-9840-5e1da32169db︡{"file":{"filename":"/tmp/tmp2kVD4c.png","show":true,"text":null,"uuid":"061f8986-8140-41bb-8f2f-e7b8588ad494"},"once":false}︡{"done":true}︡
︠a5f934ce-bb72-4502-8cb2-11b379038dcai︠
%md
`solveset` in action (like solve, but returns all solutions or a set of solutions)
︡7cab6367-011b-48ce-a04f-6ef9fe4706f5︡{"done":true,"md":"`solveset` in action (like solve, but returns all solutions or a set of solutions)"}
︠8c9984f2-e467-432a-a74b-23e1af443341︠
ex1 = sympify('x^2 / x', evaluate=False)
solveset(ex1)
︡1ce8504a-ab38-47dc-8136-c8492d0ae952︡{"file":{"filename":"/tmp/tmpmGUDbz.png","show":true,"text":null,"uuid":"300b3b55-e9ca-4b0a-8b8d-71885349f949"},"once":false}︡{"done":true}︡
︠a7e3b5f1-a797-4306-a12b-fbe8b9dfc449︠
ex2 = sympify('(x+1)^2/(x+1)', evaluate=False)
solveset(ex2)
︡0ad66a93-2ad7-4c5f-a08b-de0daf5a0ff9︡{"file":{"filename":"/tmp/tmpPdXID_.png","show":true,"text":null,"uuid":"300b3b55-e9ca-4b0a-8b8d-71885349f949"},"once":false}︡{"done":true}︡
︠487a9566-9b9a-4c51-8efb-847b154abf2b︠
ex3 = sympify('(x+1)^2', evaluate=False)
solveset(ex3)
︡1896bfe5-3da5-4f09-809e-fbeda4d245af︡{"file":{"filename":"/tmp/tmpr4EGdA.png","show":true,"text":null,"uuid":"b728a07a-8f36-43b2-b3f6-f61001f7f491"},"once":false}︡{"done":true}︡
︠8d02ed3c-74dd-45a3-b2fa-8b41981dbc40i︠
%md
`roots` for polynomials shows the multiplicity
︡f1fec3be-7eba-4466-b167-b8e4c2a1d95e︡{"done":true,"md":"`roots` for polynomials shows the multiplicity"}
︠33b2dab1-f3c1-44df-8487-842fd705cee4︠
roots(ex3)
︡81402bd3-ddf0-4db2-bf20-55d863860881︡{"file":{"filename":"/tmp/tmpfNO2cv.png","show":true,"text":null,"uuid":"6d62b521-2834-4809-9690-604944d194b6"},"once":false}︡{"done":true}︡
︠6c45182d-af6a-42b3-818f-bd6c3f709e8b︠
ex4 = sympify('(x+1)/((x+1) * (x-1))', evaluate=False)
solveset(ex4)
︡e9819aff-6e12-46e3-aa96-21b98493f066︡{"file":{"filename":"/tmp/tmpfHDzmo.png","show":true,"text":null,"uuid":"300b3b55-e9ca-4b0a-8b8d-71885349f949"},"once":false}︡{"done":true}︡
︠99726cd2-1897-4026-bf27-25774438f6a7︠
ex5 = sympify('(x * (x-2) * (x + 3)^2) / (x - 2)', evaluate=False)
solveset(ex5)
︡89332d4b-7585-47a2-b4d1-2431082207ab︡{"file":{"filename":"/tmp/tmpxBWEfD.png","show":true,"text":null,"uuid":"824f08d0-cde2-4a78-bc9c-4f7333885e4a"},"once":false}︡{"done":true}︡
︠630e6dd9-fb17-409f-913d-2d917e9ff40f︠
ex6 =  Eq(x - 1, (x + 1) / (x - 1))
ex6
︡c5fda997-7839-4564-a7dd-00495d9cffa5︡{"file":{"filename":"/tmp/tmpK_el_X.png","show":true,"text":null,"uuid":"cbac6e3f-3dba-4723-a86e-823617b9cafd"},"once":false}︡{"done":true}︡
︠3f9f1166-379c-4b08-a957-82958c0e4aac︠
solveset(ex6)
︡721634f9-c5ce-4734-8c82-537ea1b4380c︡{"file":{"filename":"/tmp/tmpyoZHyl.png","show":true,"text":null,"uuid":"80936d69-6d47-4195-bdbd-7e4061c48486"},"once":false}︡{"done":true}︡
︠e49874e5-c3e4-46b1-9780-e7b3aec149c1︠
ex7 = Eq(x**3 - 2*x + 1, 1+x)
solveset(ex7)
︡986a6d8f-60e3-4435-a580-442452399564︡{"file":{"filename":"/tmp/tmpGWcJbp.png","show":true,"text":null,"uuid":"0b16936d-0e62-434c-a29e-1050ae488875"},"once":false}︡{"done":true}︡
︠02a44917-91e9-4ee0-ad03-c29da5464324︠
solveset(sympify('(x^2+2*x+1)/(x+1)', evaluate = False))
︡47b22d6b-46ac-4c1d-8a38-5dd085d3fb41︡{"file":{"filename":"/tmp/tmpJ5X01M.png","show":true,"text":null,"uuid":"300b3b55-e9ca-4b0a-8b8d-71885349f949"},"once":false}︡{"done":true}︡
︠f1ce6443-ddfb-4957-8430-8fb2f2dbc4ff︠
solveset(sympify('(x^2+2*x+1)/(x-1)^2', evaluate = False))
︡c29572f4-348b-4fe0-81e7-52d54bb5a2b7︡{"file":{"filename":"/tmp/tmpnBUWtb.png","show":true,"text":null,"uuid":"b728a07a-8f36-43b2-b3f6-f61001f7f491"},"once":false}︡{"done":true}︡
︠160933bd-1015-426c-b2fe-ee01d54d3c40i︠
%md
Below, `0` is not a solution
︡4c87f3c2-5d25-47b0-a1e8-cec368805cf2︡{"done":true,"md":"Below, `0` is not a solution"}
︠d702c1bd-d684-4ae1-9264-6c83c8af2e42s︠
solveset(sympify('(x^3 - x^2) / x', evaluate=False))
︡43f409d7-5622-4d5d-a56b-eb2c9cefa39b︡{"file":{"filename":"/tmp/tmpONgwo3.png","show":true,"text":null,"uuid":"02a08d06-e1fc-414b-9029-ad30e92614ca"},"once":false}︡{"done":true}︡
︠7c7e61ff-2cec-445f-bafd-35b73f2e3876s︠
simplify((x**3 - x**2) / x)
︡89f47377-dc87-48d9-8dda-e689bc4f4eef︡{"file":{"filename":"/tmp/tmpLWsWDI.png","show":true,"text":null,"uuid":"f46264bb-642f-49a0-bf20-76a860a74693"},"once":false}︡{"done":true}︡
︠3042d0af-9f03-414b-b327-32a37d65e054s︠
solveset(simplify((x**3 - x**2) / x))
︡0a7cabb8-8a8d-4ab0-8c25-c5b1c66dc007︡{"file":{"filename":"/tmp/tmpcdy8Qj.png","show":true,"text":null,"uuid":"e0a49171-e6af-40f7-8f1f-da1552c98f76"},"once":false}︡{"done":true}︡
︠afd613d7-5238-4aee-a437-55f3cd2dd5b3i︠
%md
use `root` to see that $-1$ has multiplicity of 2 (only works for polynomial-like expressions)
︡fce82c26-ada3-4d64-bdfb-047dcfcaf104︡{"done":true,"md":"use `root` to see that $-1$ has multiplicity of 2 (only works for polynomial-like expressions)"}
︠2420d850-2cc3-4a1e-98d6-7695bd733e4cs︠
roots(sympify('x^2+2*x+1'), x)
︡8e0600cb-2b94-4edf-9e51-486f91c10bb9︡{"file":{"filename":"/tmp/tmpxvHYIB.png","show":true,"text":null,"uuid":"6d62b521-2834-4809-9690-604944d194b6"},"once":false}︡{"done":true}︡
︠d8e7b502-af6c-4636-9eff-ccb676501a40s︠
sympify('x/x')
︡6d86d948-c82a-4e0f-8e03-7d2e8153b2e3︡{"file":{"filename":"/tmp/tmpZTWa3C.png","show":true,"text":null,"uuid":"3fd78ceb-532c-4631-aded-b9df72bd4201"},"once":false}︡{"done":true}︡
︠dd731f16-1655-4736-8ffc-7d806e08a31bs︠
sympify('x/x', evaluate=False)
︡f6f49968-e913-4128-ade8-5b973a775c99︡{"file":{"filename":"/tmp/tmp0JjSxi.png","show":true,"text":null,"uuid":"27521712-2cc2-4306-82ff-dbe10444644a"},"once":false}︡{"done":true}︡
︠cb00fa99-9e2e-4ab6-b67a-ba68a20405d3︠









